﻿using System;
using System.ComponentModel;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using Microsoft.SharePoint;
using Microsoft.SharePoint.WebControls;
using Microsoft.Exchange.WebServices.Data;
using System.Collections.Generic;

namespace Exchange_Calendar.Calendar
{
    [ToolboxItemAttribute(false)]
    public class Calendar : WebPart
    {
        private string Domain = "Domaine";
        [WebBrowsable(true), WebDescription("Domaine"), WebDisplayName("Domaine"), Personalizable(PersonalizationScope.User), Category("OWA Einstellungen")]
        public string Domaine
        {
            get { return Domain; }
            set { Domain = value; }
        }
        private string User = "Benutzer";
        [WebBrowsable(true), WebDescription("Login"), WebDisplayName("Username"), Personalizable(PersonalizationScope.User), Category("OWA Einstellungen")]
        public string Users
        {
            get { return User; }
            set { User = value; }
        }
        private string password = "Passwort";
        [WebBrowsable(true), WebDescription("Passwort"), WebDisplayName("Passwort"), Personalizable(PersonalizationScope.User), Category("OWA Einstellungen"), PasswordPropertyText(true)]
        public string passwords
        {
            get { return password; }
            set { password = value; }
        }
        private bool listView = false;
        [WebBrowsable(true), WebDescription("Ansicht als Liste"), WebDisplayName("ListView"), Personalizable(PersonalizationScope.User), Category("OWA Einstellungen")]
        public bool listViews
        {
            get { return listView; }
            set { listView = value; }
        }
        private bool calendarView = false;
        [WebBrowsable(true), WebDescription("Ansicht als Kalender"), WebDisplayName("CalendarView"), Personalizable(PersonalizationScope.User), Category("OWA Einstellungen")]
        public bool CalendarViews
        {
            get { return calendarView; }
            set { calendarView = value; }
        }
        private FindItemsResults<Appointment> myAppointments;




        protected override void CreateChildControls()
        {
            System.Web.UI.WebControls.Calendar myCalendar = new System.Web.UI.WebControls.Calendar();
            try
            {
                ExchangeService Service = new ExchangeService();
                Service.Credentials = new WebCredentials(User, password, Domain);
                Service.AutodiscoverUrl(User + "@" + Domain);

                DateTime startDate = DateTime.Now;
                DateTime endDate = startDate.AddDays(30);
                const int NUM_APPTS = 5;
                CalendarFolder calendar = CalendarFolder.Bind(Service, WellKnownFolderName.Calendar, new PropertySet());
                CalendarView cView = new CalendarView(startDate, endDate, NUM_APPTS);
                cView.PropertySet = new PropertySet(AppointmentSchema.Subject, AppointmentSchema.Start, AppointmentSchema.End);
                myAppointments = calendar.FindAppointments(cView);

                


                if (listView == true)
                {
                    Label ab = new Label();
                    ab.Text += "<table>";
                    foreach (Appointment appointment in myAppointments)
                    {
                        ab.Text += "<tr><td>von</td><td>" + appointment.Start.ToString() + "</td><td>bis</td><td>" + appointment.End.ToString() + "</td><td>" + appointment.Subject.ToString() + "</td></tr>";
                    }
                    ab.Text += "</table>";
                    this.Controls.Add(ab);
                }
                if (calendarView == true)
                {
                    myCalendar.DayRender += myCalendar_DayRender;
                   
                    myCalendar.DayHeaderStyle.BackColor = System.Drawing.Color.FromArgb(0, 114, 193);
                    myCalendar.DayHeaderStyle.ForeColor = System.Drawing.Color.White;
                    myCalendar.DayStyle.BackColor = System.Drawing.Color.White;
                    this.Controls.Add(myCalendar);
                }

            }
            catch (Exception ex)
            {
                Label a = new Label();
                a.Text = "Bitte geben sie ihre Daten ein!";
                this.Controls.Add(a);
            }

        }

        protected void myCalendar_DayRender(object sender, DayRenderEventArgs e)
        {

            e.Cell.Style["Height"] = "90px !important";
            e.Cell.Style["Width"] = "180px !important";
            e.Cell.Style["vertical-align"] = "Top";
            e.Cell.Style["font-size"] = "12px";
            e.Cell.BackColor = System.Drawing.Color.FromArgb(102, 203, 234);
            e.Day.IsSelectable = false;
            Label lbl = new Label();
            lbl.Text += "<table width='100%'>";
            foreach (Appointment appointment in myAppointments)
            {

                DateTime Start = appointment.Start;
                DateTime End = appointment.End;
                String Starthour = Start.Hour.ToString();
                if (Starthour.Length == 1)
                {
                    Starthour = "0" + Starthour;
                }
                String Startminute = Start.Minute.ToString();
                if (Startminute.Length == 1)
                {
                    Startminute = "0" + Startminute;
                }
                String Endhour = End.Hour.ToString();
                if (Endhour.Length == 1)
                {
                    Endhour = "0" + Endhour;
                }
                String Endminute = End.Minute.ToString();
                if (Endminute.Length == 1)
                {
                    Endminute = "0" + Endminute;
                }
                e.Cell.BorderWidth = 1;
                lbl.Style["width"] = "100% !important";
                lbl.Style["height"] = "100% !important";
                lbl.Style["display"] = "inline-block";
                lbl.Style["text-align"] = "left";

                lbl.BackColor = System.Drawing.Color.White;

                if (e.Day.Date.Day == Start.Day && e.Day.Date.Month == Start.Month)
                {

                    lbl.Text += "<tr>";
                    lbl.Text += "<td>" + appointment.Subject + "</td><td>" + Starthour + ":" + Startminute + "-" + Endhour + ":" + Endminute + "</td>";
                    lbl.Text += "</tr>";
                }

            }
            lbl.Text += "</table>";
            e.Cell.Controls.Add(lbl);
         
        }

    }
}
